"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withinFactory;
function withinFactory() {
  return function within(expression) {
    var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 45500;
    var delay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 30;
    var errorMessage = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "Timeout after " + timeout + "ms waiting for expression to be true";

    var startTime = performance.now();
    return new Promise(function (resolve, reject) {
      function checkExpression() {
        if (expression()) {
          resolve(true);
          return;
        }

        if (performance.now() - startTime < timeout) {
          window.setTimeout(checkExpression, delay);
          return;
        }

        reject(new Error(errorMessage));
      }
      checkExpression();
    });
  };
}