'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = process;

var _processBrowser = require('./processBrowser.js');

var _processBrowser2 = _interopRequireDefault(_processBrowser);

var _processCheerio = require('./processCheerio.js');

var _processCheerio2 = _interopRequireDefault(_processCheerio);

var _processRegex = require('./processRegex.js');

var _processRegex2 = _interopRequireDefault(_processRegex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function process(_ref) {
  var browser = _ref.browser;
  var cheerio = _ref.cheerio;
  var queueItem = _ref.queueItem;
  var scraper = _ref.scraper;

  // browser, url, fn
  // @todo move the url filtering logic here so it's shared amongst the different
  // process functions
  function switchUse(use) {
    scraper.log('Using ' + use + ' for ' + queueItem.url);
    switch (use) {
      case 'browser':
      default:
        return (0, _processBrowser2.default)({ browser: browser, queueItem: queueItem, scraper: scraper });
      case 'cheerio':
        return (0, _processCheerio2.default)({ cheerio: cheerio, queueItem: queueItem, scraper: scraper, switchUse: switchUse });
      case 'regex':
        return (0, _processRegex2.default)({ queueItem: queueItem, scraper: scraper, switchUse: switchUse });
    }
  }

  return switchUse(queueItem.use || scraper.use || 'browser').then(function (data) {
    console.log(queueItem, data);
    if (data.data && data.data.finalUrl) {
      // eslint-disable-next-line no-param-reassign
      data.finalUrl = data.data.finalUrl;
    }
    return data;
  });
}